## seqan2 2.5.2

=== CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /CMakeLists.txt
#
# Main CMakeLists.txt file.
# ===========================================================================

# ===========================================================================
# We require CMake 3.12. Since it is available in the currently stable
# Debian, it should be available everywhere else, too.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)

project (seqan CXX)

# ===========================================================================
# Warn People About the Perils Of In-Source Builds
# ===========================================================================

if (EXISTS "$CMAKE_BINARY_DIR/CMakeLists.txt")
  if (EXISTS "$CMAKE_BINARY_DIR/I_WANT_IN_SOURCE_BUILDS")
    set (IN_SOURCE_BUILD YES)
  else (EXISTS "$CMAKE_BINARY_DIR/I_WANT_IN_SOURCE_BUILDS")
    message ("CAUTION: In-source builds are not allowed by default!")
    message ("")
    message ("(If you want to use Eclipse and have read the 'Getting Started,")
    message ("with Eclipse Tutorial' then see the instructions below.)")
    message ("")
    message ("Instead of doing in source builds, go to into the directory build")
    message ("and call CMake from there.")
    message ("We recommend you to create an additional directory level, this")
    message ("allows you to have multiple build configurations (e.g. Debug,")
    message ("Release) or project types.")
    message ("")
    message ("  cd build")
    message ("  mkdir Debug")
    message ("  cd Debug")
    message ("  cmake ../.. -DCMAKE_BUILD_TYPE=Debug")
    message ("")
    message ("NOTE: CMake has created some files in this directory that you have")
    message ("to remove before executing the above commands.")
    message ("")
    message ("  [Linux, Mac Os X]  rm -rf CMakeCache.txt CMakeFiles")
    message ("  [Windows]          del CMakeCache.txt ; rmdir /S CMakeFiles")
    message ("")
    message ("If you want to use Eclipse then you might want to have in-source")
    message ("builds because of limitations of Eclipse CDT4.  In this case")
    message ("Create a file in this directory called I_WANT_IN_SOURCE_BUILDS:")
    message ("")
    message ("  [Linux, Mac Os X]  touch I_WANT_IN_SOURCE_BUILDS")
    message ("  [Windows]          type nul >> I_WANT_IN_SOURCE_BUILDS")
    message ("")
    message (FATAL_ERROR "Please follow the instructions above.")
  endif (EXISTS "$CMAKE_BINARY_DIR/I_WANT_IN_SOURCE_BUILDS")
endif (EXISTS "$CMAKE_BINARY_DIR/CMakeLists.txt")

# ===========================================================================
# Setup Variables
# ===========================================================================

if (NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE Release CACHE STRING
         "Choose the type of build, options are: Debug Release RelWithDebInfo ..."
         FORCE)
endif (NOT CMAKE_BUILD_TYPE)

# Clear CTD executable list, will be set on reconfiguration.
set (SEQAN_CTD_EXECUTABLES CACHE INTERNAL "Global list of executables for workflow integration.")

# ===========================================================================
# Build System Configuration Variables
# ===========================================================================

option (SEQAN_STATIC_APPS "Build static apps." OFF)
option (SEQAN_ARCH_SSE4 "Build SSE optimized binaries." OFF)
option (SEQAN_ARCH_AVX2 "Build AVX2 optimized binaries." OFF)
option (SEQAN_ARCH_AVX512_KNL "Build AVX512 optimized binaries for Knights Landing." OFF)
option (SEQAN_ARCH_AVX512_SKX "Build AVX512 optimized binaries for Skylake." OFF)
option (SEQAN_ARCH_AVX512_CNL "Build AVX512 optimized binaries for Cannon Lake." OFF)
option (SEQAN_ARCH_NATIVE "Build natively optimized binaries." OFF)

# ===========================================================================
# Version Check Variables.
# ===========================================================================

option (SEQAN_VERSION_CHECK_OPT_IN "Enable version check but activate as opt-in." OFF)
option (SEQAN_DISABLE_VERSION_CHECK "Disable version check." OFF)

# ===========================================================================
# Setup Modules and Find Packages.
# ===========================================================================

# Note that the find modules in util/make take precedence
# over the built-in ones from CMake.  This is used in
# FindBZip2, for example which we slightly modify.
set (CMAKE_MODULE_PATH
    ${CMAKE_CURRENT_SOURCE_DIR}/util/cmake/FindTBB
    ${CMAKE_CURRENT_SOURCE_DIR}/util/cmake
    ${CMAKE_MODULE_PATH})

#message (STATUS "CMAKE_MODULE_PATH is ${CMAKE_MODULE_PATH}")

# ===========================================================================
# Add contrib to CMAKE_FIND_ROOT_PATH.
# ===========================================================================

include (SeqAnContribs)

# ===========================================================================
# Build Mode Branches
# ===========================================================================

message (STATUS "Initializing SeqAn Build System...")

set (SEQAN_USE_SEQAN_BUILD_SYSTEM TRUE CACHE INTERNAL "Use SeqAn build system." FORCE)

#set (SEQAN_PREFIX_SHARE .)
include (SeqAnBuildSystem)
set (SEQAN_ROOT_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}" CACHE INTERNAL "Root source directory." FORCE)
seqan_get_version ()
seqan_build_system_init ()
seqan_get_repository_info ()

# ===========================================================================
# Search for Python3 once
# ===========================================================================
if (NOT Python3_Interpreter_FOUND)
  find_package (Python3)
endif ()

# ===========================================================================
# Include Subdirectories
# ===========================================================================

if ("${SEQAN_BUILD_SYSTEM}" STREQUAL "DOCUMENTATION")
  message (STATUS "Configuring dox")
  add_subdirectory (dox)

  message (STATUS "Configuring manual")
  add_subdirectory (manual)

  return ()
endif ()

# Tests, demos and manual are only built when building in DEVELOP mode.
if ("${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    message (STATUS "Configuring tests")
    add_subdirectory (tests)

    message (STATUS "Configuring demos")
    add_subdirectory (demos)

    if (NOT SEQAN_NO_DOX)
        message (STATUS "Configuring manual")
        add_subdirectory (manual)
    endif ()
endif ()

if ((("${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP") OR
     ("${SEQAN_BUILD_SYSTEM}" STREQUAL "SEQAN_RELEASE_LIBRARY")) AND
     (NOT SEQAN_NO_DOX))

    message (STATUS "Configuring dox")
    add_subdirectory (dox)

    if ("${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
        message (STATUS "Configuring util/py_lib")
        add_subdirectory (util/py_lib)
    endif ()
endif ()

if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "SEQAN_RELEASE_LIBRARY")
    message (STATUS "Configuring apps")
    add_subdirectory (apps)
endif ()

# ===========================================================================
# Register Libraries (for GUI project generators)
# ===========================================================================

seqan_setup_library ()

# ===========================================================================
# Include CPack
# ===========================================================================

include (package)

# ===========================================================================
# Check Optional Libraries, Print Usage
# ===========================================================================

#include (FeatureSummary)

# ===========================================================================
# Setup Common Tool Description for Generic Workflow Nodes
# ===========================================================================

include (SeqAnCtdSetup)

=== apps/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/CMakeLists.txt
#
# CMakeLists.txt file for the core apps.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_apps CXX)

# Register all apps in core.  The apps will be built in SEQAN_RELEASE mode or
# the apps called ${app} in APP:${app} mode.

# Strip the build path from app binaries. These are included by macros such as FAIL().
# Used for packaging, e.g., Debian.
if (DEFINED SEQAN_STRIP_APPS_BUILD_PATH)
    set (SEQAN_CXX_FLAGS_BACKUP ${SEQAN_CXX_FLAGS})
    set (SEQAN_CXX_FLAGS ${SEQAN_CXX_FLAGS}  -ffile-prefix-map=${SEQAN_STRIP_APPS_BUILD_PATH}=.)
    seqan_register_apps ()
    set (SEQAN_CXX_FLAGS ${SEQAN_CXX_FLAGS_BACKUP})
    unset (SEQAN_CXX_FLAGS_BACKUP)
else ()
    seqan_register_apps ()
endif ()

=== dox/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /dox/CMakeLists.txt
#
# CMakeLists.txt file for dox.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_dox CXX)

if (NOT Python3_Interpreter_FOUND)
    find_package (Python3)
endif ()
if (NOT Python3_Interpreter_FOUND)
    message (STATUS "  You need Python for building dox. (skipping)")
    return ()
endif ()

# require jinja2 python package
execute_process(COMMAND ${Python3_EXECUTABLE} -c "import jinja2"
                RESULT_VARIABLE PYTHON_JINJA2_NOT_FOUND
                OUTPUT_VARIABLE _IGNORED
                ERROR_VARIABLE _IGNORED)

if (PYTHON_JINJA2_NOT_FOUND)
  message (STATUS "  The Python package jinja2 is required for building dox ('import jinja2' failed). (skipping)")
  return ()
endif (PYTHON_JINJA2_NOT_FOUND)

# Add building the documentation as a test.
add_test (build_dox
  ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../util/bin/dox.py
  -b ${CMAKE_CURRENT_SOURCE_DIR}/..
  -i ${CMAKE_CURRENT_SOURCE_DIR}/../include/seqan
  -i ${CMAKE_CURRENT_SOURCE_DIR}/pages
  --image-dir ${CMAKE_CURRENT_SOURCE_DIR}/images)

if (${SEQAN_BUILD_SYSTEM} MATCHES "SEQAN_RELEASE_LIBRARY") # includes SEQAN_RELEASE_LIBRARY
    add_custom_target (dox ALL
        cd ${CMAKE_CURRENT_SOURCE_DIR} && ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../util/bin/dox.py
        -b ${CMAKE_CURRENT_SOURCE_DIR}/..
        -i ${CMAKE_CURRENT_SOURCE_DIR}/../include/seqan
        -i ${CMAKE_CURRENT_SOURCE_DIR}/pages
        --image-dir ${CMAKE_CURRENT_SOURCE_DIR}/images
        --out-dir ${CMAKE_BINARY_DIR}/dox/html)

    install (DIRECTORY ${CMAKE_BINARY_DIR}/dox/html
             DESTINATION ${CMAKE_INSTALL_DOCDIR})
endif ()

=== manual/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /manual/CMakeLists.txt
#
# CMakeLists.txt file for manual.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_manual CXX)

if (NOT Python3_Interpreter_FOUND)
    find_package (Python3)
endif ()
if (NOT Python3_Interpreter_FOUND)
    message (STATUS "  You need Python for building the manual. (skipping)")
    return ()
endif ()

# require jinja2 python package
execute_process(COMMAND ${Python3_EXECUTABLE} -c "import jinja2"
                RESULT_VARIABLE PYTHON_JINJA2_NOT_FOUND
                OUTPUT_VARIABLE _IGNORED
                ERROR_VARIABLE _IGNORED)

if (PYTHON_JINJA2_NOT_FOUND)
  message (STATUS "  The Python package jinja2 is required for building the manual ('import jinja2' failed). (skipping)")
  return ()
endif (PYTHON_JINJA2_NOT_FOUND)

# Look for Sphinx and balk out if we cannot find it.

find_package (Sphinx)

if (NOT SPHINX_FOUND)
    message (STATUS "  Sphinx not found, not building sphinx manual as a test.")
    return ()
endif (NOT SPHINX_FOUND)

# Add building Sphinx documentation as a test.

add_test (build_manual
          ${SPHINX_EXECUTABLE} -W -n
          -b html -d ${CMAKE_BINARY_DIR}/manual/doctrees
          ${CMAKE_CURRENT_SOURCE_DIR}/source
          ${CMAKE_BINARY_DIR}/manual/html)

# Building the manual depends on the JSON file from dox.
set_tests_properties(build_manual PROPERTIES DEPENDS build_dox)

=== apps/alf/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/alf/CMakeLists.txt
#
# CMakeLists.txt file for ALF.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_apps_alf CXX)
message (STATUS "Configuring apps/alf")

set (SEQAN_APP_VERSION "1.1.14")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (alf alf.cpp)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (alf ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (alf)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install alf in ${PREFIX}/bin directory
install (TARGETS alf
         DESTINATION ${CMAKE_INSTALL_BINDIR})

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/alf for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/small.fasta
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

#seqan_add_app_test (alf)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include executable seqan_tcoffee in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} alf CACHE INTERNAL "")

#Add test to check correct ctd generation.
seqan_add_ctd_test (alf)

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:alf")
  set (CPACK_PACKAGE_NAME "alf")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "alf - Alignment Free Sequence Comparison")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (alf "alf")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:alf")

=== apps/bs_tools/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/bs_tools/CMakeLists.txt
#
# CMakeLists.txt file for bs_tools.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_apps_bs_tools CXX)
message (STATUS "Configuring apps/bs_tools")

set (SEQAN_APP_VERSION "0.1.14")

if ((${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD") AND ("$ENV{MODEL}" STREQUAL "Nightly"))
    message (STATUS "bs_tools skipped on FreeBSD because math.h rounding errors.")
    return ()
endif ()

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (ZLIB)
    find_package (Boost)
    find_package (SeqAn CONFIG REQUIRED)
endif ()

if (NOT Boost_FOUND)
    message (STATUS "  Skipping bs_tools, missing Boost")
    return ()
endif ()

if (NOT ZLIB_FOUND)
    message (STATUS "  Skipping bs_tools, missing zlib")
    return ()
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})
include_directories (SYSTEM ${Boost_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")

# Update the list of file names below if you add source files to your application.
add_executable (bisar bisar.cpp
                    bisar.h
                    bisar_base.h
                    bisar_score.h
                    bisar_score_data.h)

add_executable (casbar casbar.cpp
                    casbar.h
                    casbar_calling.h
                    casbar_realignment.h
                    casbar_consensus_realign.h
                    casbar_score.h
                    casbar_score_data.h
                    casbar_util.h
                    casbar_alphabets.h)

add_executable (four2three four2three.cpp
                    four2three.h)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (bisar ${SEQAN_LIBRARIES})
target_link_libraries (casbar ${Boost_LIBRARIES} ${SEQAN_LIBRARIES})
target_link_libraries (four2three ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include bs_tools executables in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES}
        bisar
        casbar
        four2three
        CACHE INTERNAL "")

#Add test to check correct ctd generation.
seqan_add_ctd_test (bisar)
seqan_add_ctd_test (casbar)
seqan_add_ctd_test (four2three)

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (bs_tools)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install bs_tools in ${PREFIX}/bin directory
install (TARGETS bisar casbar four2three
         DESTINATION ${CMAKE_INSTALL_BINDIR})

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/bs_tools for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
#install (FILES example/fasta1.fa
#               example/fasta2.fa
#         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

# if (SEQAN_BUILD_SYSTEM STREQUAL "DEVELOP")
#     include("SeqAnConsistentFPFlags")
#     set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CONSISTENT_FP_FLAGS}")
# endif()

# (weese:) temporarily disabled app test
seqan_add_app_test (bs_tools)

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:bs_tools")
  set (CPACK_PACKAGE_NAME "bs_tools")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "bs_tools")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Sabrina Krakau <sabrina.krakau@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (bs_tools "bs_tools")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:bs_tools")

=== apps/dfi/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/dfi/CMakeLists.txt
#
# CMakeLists.txt file for DFI.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_apps_dfi CXX)
message (STATUS "Configuring apps/dfi")

set (SEQAN_APP_VERSION "2.1.14")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (dfi dfi.cpp)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (dfi ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (dfi)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install dfi in ${PREFIX}/bin directory
install (TARGETS dfi
         DESTINATION ${CMAKE_INSTALL_BINDIR})

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/dfi for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/fasta1.fa
               example/fasta2.fa
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (dfi)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include executable razers in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} dfi CACHE INTERNAL "")

#Add test to check correct ctd generation.
seqan_add_ctd_test (dfi)

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:dfi")
  set (CPACK_PACKAGE_NAME "dfi")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "DFI - Fast String Mining of Multiple Databases under Frequency Constraints")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "David Weese <david.weese@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (dfi "DFI")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:dfi")

=== apps/fiona/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: apps/fiona/CMakeLists.txt
#
# CMakeLists.txt file for fiona.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_apps_fiona CXX)
message (STATUS "Configuring apps/fiona")

set (SEQAN_APP_VERSION "0.2.14")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (OpenMP COMPONENTS CXX)
    find_package (ZLIB)
    find_package (Boost)
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# Stop here if we cannot find Boost or OpenMP.
if (NOT Boost_FOUND)
    message (STATUS "  Skipping fiona, missing Boost")
    return ()
endif ()

if (NOT OPENMP_FOUND)
    message (STATUS "  Skipping fiona, missing OpenMP")
    return ()
endif ()

if (NOT CMAKE_SIZEOF_VOID_P EQUAL 8)
    message (STATUS "  Skipping fiona on 32-bit architectures")
    return ()
endif()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})
include_directories (SYSTEM ${Boost_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})
#add_definitions("-DQGRAM_LENGTH=5")

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (compute_gain compute_gain.cpp)
add_executable (fiona fiona.cpp)
add_executable (fiona_illumina fiona.cpp)

set_target_properties (fiona_illumina PROPERTIES COMPILE_DEFINITIONS "FIONA_ILLUMINA")

# Boost 1.74.0 is not compatible with cpp20
set_property(TARGET fiona PROPERTY CXX_STANDARD 17)
set_property(TARGET fiona_illumina PROPERTY CXX_STANDARD 17)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (compute_gain ${SEQAN_LIBRARIES})
target_link_libraries (fiona ${SEQAN_LIBRARIES})
target_link_libraries (fiona_illumina ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (fiona)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install fiona in ${PREFIX}/bin directory
install (TARGETS fiona fiona_illumina compute_gain DESTINATION ${CMAKE_INSTALL_BINDIR})

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/fiona for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/reads.fa
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------
if (NOT MSVC)
    seqan_add_app_test (fiona)
else ()
    message (STATUS "  Skipping fiona tests on Visual Studio")
endif ()

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include executable fiona in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} fiona fiona_illumina compute_gain CACHE INTERNAL "")

#Add test to check correct ctd generation.
seqan_add_ctd_test (fiona)
seqan_add_ctd_test (fiona_illumina)
seqan_add_ctd_test (compute_gain)

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:fiona")
  set (CPACK_PACKAGE_NAME "fiona")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "fiona")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "David Weese <david.weese@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (fiona "fiona")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:fiona")

=== apps/fx_tools/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/fx_tools/CMakeLists.txt
#
# CMakeLists.txt file for fx_tools.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_apps_fx_tools CXX)
message (STATUS "Configuring apps/fx_tools")

set (SEQAN_APP_VERSION "0.2.14")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Setup SeqAn requirements.
include_directories (${SEQAN_INCLUDE_DIRS})
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# Computation of coverage and C+G content from genome and mapping.
add_executable (fx_bam_coverage fx_bam_coverage.cpp)
target_link_libraries (fx_bam_coverage ${SEQAN_LIBRARIES})

# Computation of statistics on FASTQ files.
add_executable (fx_fastq_stats fx_fastq_stats.cpp)
target_link_libraries (fx_fastq_stats ${SEQAN_LIBRARIES})

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (fx_tools)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install fx_tools in ${PREFIX}/bin directory
install (TARGETS fx_bam_coverage
         DESTINATION ${CMAKE_INSTALL_BINDIR})

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/fx_tools for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
#install (FILES example/fasta1.fa
#               example/fasta2.fa
#         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

#seqan_add_app_test (fx_tools)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include executable razers in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} fx_fastq_stats fx_bam_coverage CACHE INTERNAL "")

#Add test to check correct ctd generation.
seqan_add_ctd_test (fx_fastq_stats)
seqan_add_ctd_test (fx_bam_coverage)

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:fx_tools")
  set (CPACK_PACKAGE_NAME "fx_tools")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "fx_tools")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")

  seqan_configure_cpack_app (fx_tools "fx_tools")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:fx_tools")

=== apps/gustaf/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/gustaf/CMakeLists.txt
#
# CMakeLists.txt file for gustaf.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_apps_gustaf CXX)
message (STATUS "Configuring apps/gustaf")

set (SEQAN_APP_VERSION "1.0.14")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (gustaf gustaf.cpp
                create_stellarmatches_from_file.h
                gustaf_matepairs.h
                msplazer.h
                msplazer_algorithms.h
                msplazer_main.h
                msplazer_out.h
                msplazer_parse_options.h
                stellar_routines.h
)

add_executable (gustaf_mate_joining join_mates.cpp
                create_stellarmatches_from_file.h
                gustaf_matepairs.h
                msplazer.h
                msplazer_algorithms.h
                msplazer_main.h
                msplazer_out.h
                msplazer_parse_options.h
                stellar_routines.h
)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (gustaf ${SEQAN_LIBRARIES})
target_link_libraries (gustaf_mate_joining ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (gustaf)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install gustaf in ${PREFIX}/bin directory
install (TARGETS gustaf gustaf_mate_joining
         DESTINATION ${CMAKE_INSTALL_BINDIR})

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/gustaf for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/adeno.fa
               example/adeno_modified.fa
               example/adeno_modified_reads.fa
               example/stellar.gff
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (gustaf)


# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:gustaf")
  set (CPACK_PACKAGE_NAME "gustaf")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "Gustaf - Generic multi-split alignment finder")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Kathrin Trappe <kathrin.trappe@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "Kathrin Trappe <kathrin.trappe@fu-berlin.de>")
  set (CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.rst")

  seqan_configure_cpack_app (gustaf "gustaf")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:gustaf")

=== apps/insegt/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/insegt/CMakeLists.txt
#
# CMakeLists.txt file for insegt.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_apps_insegt CXX)
message (STATUS "Configuring apps/insegt")

set (SEQAN_APP_VERSION "1.1.14")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (insegt
                insegt.cpp
                base.h
                create_gff.h
                fusion.h
                overlap_module.h)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (insegt ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (insegt)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install insegt in ${PREFIX}/bin directory
install (TARGETS insegt
         DESTINATION ${CMAKE_INSTALL_BINDIR})

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/insegt for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/annoOutput.gff
               example/annotations.gff
               example/readOutput.gff
               example/tupleOutput.gff
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

# Add app tests if Python interpreter could be found.
if(PYTHONINTERP_FOUND)
  add_test(NAME app_test_insegt COMMAND ${Python3_EXECUTABLE}
    ${CMAKE_CURRENT_SOURCE_DIR}/tests/run_tests.py ${CMAKE_SOURCE_DIR}
    ${CMAKE_BINARY_DIR})
endif(PYTHONINTERP_FOUND)

seqan_add_app_test (insegt)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include executable razers in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} insegt CACHE INTERNAL "")

#Add test to check correct ctd generation.
seqan_add_ctd_test (insegt)

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:insegt")
  set (CPACK_PACKAGE_NAME "insegt")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "insegt - Alignment Free Sequence Comparison")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (insegt "insegt")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:insegt")

=== apps/mason2/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /mason2/CMakeLists.txt
#
# CMakeLists.txt file for mason2.
# ===========================================================================

cmake_minimum_required (VERSION 3.12)
project (seqan_apps_mason2 CXX)
message (STATUS "Configuring apps/mason2")

set (SEQAN_APP_VERSION "2.0.13")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (OpenMP COMPONENTS CXX)
    find_package (ZLIB)
    find_package (SeqAn CONFIG REQUIRED)
endif ()

if (NOT ZLIB_FOUND)
  message (STATUS "  ZLIB not found: MASON2 will not be built.")
  return ()
endif (NOT ZLIB_FOUND)

# Enable C++11 in GCC and/or CLANG.
#if (CMAKE_COMPILER_IS_GNUCXX OR COMPILER_IS_CLANG)
#    add_definitions ("-std=c++0x")
#endif (CMAKE_COMPILER_IS_GNUCXX OR COMPILER_IS_CLANG)

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# We define a library for the reusable parts of Mason.
add_library (mason_sim
             external_split_merge.h
             external_split_merge.cpp
             fragment_generation.h
             genomic_variants.h
             genomic_variants.cpp
             individual_genome.h
             mason_options.cpp
             mason_options.h
             mason_types.h
             methylation_levels.cpp
             methylation_levels.h
             omp_wrapper.h
             sequencing.h
             simulate_454.cpp
             simulate_base.cpp
             simulate_genome.cpp
             simulate_genome.h
             simulate_illumina.cpp
             simulate_sanger.cpp
             variation_size_tsv.h
             vcf_materialization.cpp
             vcf_materialization.h)
target_link_libraries (mason_sim seqan::seqan2)

# Simulate random genomes.
add_executable (mason_genome mason_genome.cpp)

# Simulate methylation levels for gnome.
add_executable (mason_methylation mason_methylation.cpp)

# Simulate sequencing of fragments.
add_executable (mason_frag_sequencing mason_frag_sequencing.cpp)

# Simulation of structural variants into FASTA sequences.
add_executable (mason_variator mason_variator.cpp)

# The materializer reads in FASTA and VCF and writes out FASTA.
add_executable (mason_materializer mason_materializer.cpp)

# The end-to-end read simulator includes materialization and fragment sampling.
add_executable (mason_simulator mason_simulator.cpp)

# Simulation splicing given a reference, GFF/GTF file, and possibly VCF for variants.
add_executable (mason_splicing mason_splicing.cpp)

# Tests for some of the library functionality.
add_executable (mason_tests mason_tests.cpp)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (mason_frag_sequencing mason_sim)
target_link_libraries (mason_genome mason_sim)
target_link_libraries (mason_materializer mason_sim)
target_link_libraries (mason_methylation mason_sim)
target_link_libraries (mason_simulator mason_sim)
target_link_libraries (mason_splicing mason_sim)
target_link_libraries (mason_tests mason_sim)
target_link_libraries (mason_variator mason_sim)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include mason executables in CTD structure.
set (SEQAN_CTD_EXECUTABLES
    ${SEQAN_CTD_EXECUTABLES}
    mason_genome
    mason_frag_sequencing
    mason_variator
    mason_materializer
    mason_simulator
    CACHE INTERNAL "")

#Add test to check correct ctd generation.
seqan_add_ctd_test (mason_genome)
seqan_add_ctd_test (mason_frag_sequencing)
seqan_add_ctd_test (mason_variator)
seqan_add_ctd_test (mason_materializer)
seqan_add_ctd_test (mason_simulator)

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (mason2)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install Mason binaries in ${PREFIX}/bin directory
install (TARGETS mason_frag_sequencing
                 mason_genome
                 mason_materializer
                 mason_methylation
                 mason_simulator
                 mason_splicing
                 mason_variator
         DESTINATION ${CMAKE_INSTALL_BINDIR})

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/mason2 for SeqAn release builds.
install (FILES LICENSE
               README
               README.mason_frag_sequencing
               README.mason_genome
               README.mason_materializer
               README.mason_methylation
               README.mason_simulator
               README.mason_splicing
               README.mason_variator
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/adeno_virus.fa
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

if (NOT MSVC)
    seqan_add_app_test (mason2)
else ()
    message (STATUS "  Skipping mason2 tests on Visual Studio")
endif ()

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:mason2")
  set (CPACK_PACKAGE_NAME "mason2")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "Versatile package for the simulation of nucleic sequence.")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")

  seqan_configure_cpack_app (mason2 "mason2")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:mason2")

=== debian/changelog ===
seqan2 (2.5.2-1) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * d/rules: remove workaround for archs we no longer build for.
  * d/control: drop build-dep on fakeroot
  * New upstream version
  * Standards-Version: 4.7.3 (routine-update)
  * debputy lint --auto-fix (routine-update)
  * d/patches: many patches upstreamed and removed.
  * d/rules: configure with -DALIGN_SIMD_TEST=FALSE as per upstream, to
    avoid compiling a 256+ level template in debug mode which takes up too
    much memory.
  * debian/libseqan2-dev.docs: README.rst→README.md
  * d/rules: According to upstream, solution_online_search_finder.cpp
    works again, so stop deleting that test
  * d/upstream/metadata: link to upstream's git repo
  * d/rules: re-enable maximal parallel building.
  * d/patches: Dropped skip-some-apps-on-some-archs, we don't even build for
    these archs anymore (not a current Debian port, or not 64-bit.
  * Restore demos/tutorial/file_io_overview/example.sam after running
    the tests, instead of deleting it via d/clean.

  [ Enrico Seiler ]
  * d/control: remove unneeded deps
  * d/rules: strip path from seqan-apps
  * d/salsa-ci.yml: Skip arm64 crossbuild and reprotest, add env var for
    use by d/rules
  * d/patches: refresh patches
  * d/patches: remove forwarded patches

  [ Michael R. Crusoe ]
  Remove patch skip-some-apps-on-some-archs that is missing from debian/patches/series.

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 09 Jan 2026 09:45:46 +0100

seqan2 (2.4.0+dfsg-17) unstable; urgency=medium

  [ Santiago Vila ]
  * Fix clean target. Closes: #1047218

  [ Andreas Tille ]
  * d/watch: version=5
  * Standards-Version: 4.7.2 (routine-update)
  * Rely on pre-initialized dpkg-architecture variables.
  * Build-Depends: architecture-is-64-bit
    Closes: #917851
  * Disable i386 build on Salsa CI
  * Enable building with CMake 4

 -- Andreas Tille <tille@debian.org>  Wed, 03 Dec 2025 14:49:24 +0100

=== debian/control ===
Source: seqan2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Michael R. Crusoe <crusoe@debian.org>,
           Kevin Murray <spam@kdmurray.id.au>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               architecture-is-64-bit,
               python3 <!nocheck>,
               cmake
Build-Depends-Arch: zlib1g-dev,
                    libbz2-dev,
                    libboost-dev
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/med-team/seqan2
Vcs-Git: https://salsa.debian.org/med-team/seqan2.git
Homepage: https://www.seqan.de/
Rules-Requires-Root: no

Package: seqan-apps
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: cwltool | cwl-runner
Description: C++ library for the analysis of biological sequences
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance. This package contains the applications dfi, pair_align,
 micro_razers, seqan_tcoffee, seqcons, razers and tree_recon.

Package: libseqan2-dev
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}
Description: C++ library for the analysis of biological sequences (development)
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance.
 .
 This package contains the developer files.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# debian/rules: Disable fixfilepath feature, as it triggers build
# failures when enabled.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=-fixfilepath
include /usr/share/dpkg/pkg-info.mk
export HOME=$(CURDIR)/fakehome

# Droping -fstack-protector flag helps **drastically** reducing memory consumption when building the package!!!!
# export DEB_BUILD_MAINT_OPTIONS = hardening=-stackprotector

include /usr/share/dpkg/architecture.mk

# As per upstream's instructions
export DEB_CFLAGS_MAINT_APPEND+=-O3
export DEB_CXXFLAGS_MAINT_APPEND+=-DNDEBUG -O3

pkgapps=seqan-apps
pkgdev=libseqan2-dev

%:
	dh $@

override_dh_auto_configure-arch:
	export DEB_BUILD_ARCH=${DEB_BUILD_ARCH} ; \
	dh_auto_configure --arch -- \
		-DSEQAN_STATIC_APPS=False -DSEQAN_NO_DOX=1 \
		-DSEQAN_DISABLE_VERSION_CHECK=YES \
		-DALIGN_SIMD_TEST=FALSE \
		-DSEQAN_STRIP_APPS_BUILD_PATH="$(CURDIR)" \
		-DSEQAN_NO_DOX=1

override_dh_auto_configure-indep:
	dh_auto_configure --indep -B build -- \
		-DSEQAN_BUILD_SYSTEM=SEQAN_RELEASE_LIBRARY -DSEQAN_NO_DOX=1 \
		-DSEQAN_DISABLE_REVISION_INFO=1 \
		-DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
		-DALIGN_SIMD_TEST=FALSE \
		-Wno-dev -DCMAKE_POLICY_WARNING_CMP0160=OFF

execute_before_dh_auto_test:
	cp demos/tutorial/file_io_overview/example.sam debian/

execute_after_dh_auto_test:
	cp debian/example.sam demos/tutorial/file_io_overview/example.sam

override_dh_auto_install-indep:
	dh_auto_install --indep -B build --destdir=$(CURDIR)/debian/$(pkgdev)/
	rm -Rf $(CURDIR)/debian/$(pkgdev)/usr/share/doc/seqan

execute_after_dh_install-indep:
	# Delete additional LICENSE and compiled Python files
	if [ -d $(CURDIR)/debian/$(pkgdev) ] ; then \
	    find $(CURDIR)/debian/$(pkgdev) -type f -name LICENSE -delete ; \
	    find $(CURDIR)/debian/$(pkgdev) -type f -name "*.pyc" -delete ; \
	fi

execute_after_dh_install-arch:
	# Delete additional LICENSE files
	find $(CURDIR)/debian/$(pkgapps) -type f -name LICENSE -delete || /bin/true
	find $(CURDIR)/debian/$(pkgapps)/usr/lib/seqan/bin -type f \
		-name "*.sh" | xargs chmod a+x
#	for app in $$(ls $(CURDIR)/debian/$(pkgapps)/usr/lib/seqan/bin); \
#		do $(CURDIR)/debian/$(pkgapps)/usr/lib/seqan/bin/$${app} \
#		--write-ctd $${app}.ctd && CTDConverter cwl -i $${app}.ctd \
#		-o $(CURDIR)/debian/$(pkgapps)/usr/share/commonwl/${app}.cwl; \
#	        done;
#	rm *.ctd
#	find $(CURDIR)/debian/$(pkgapps)/usr/share/commonwl -type f \
#		-name "*.cwl" | xargs chmod a+x

execute_after_dh_auto_clean:
	find . -type f -name "*.pyc" -delete
	if [ -d orig ] ; then \
	  for header in `find orig -name "*generated_forwards.h"` ; do \
	    mv $${header} `echo $$header | sed 's?orig/??'` ; \
	  done ; \
	fi
	rm -rf orig

execute_before_dh_installman-arch:
	dh_link --arch
	if [ -d $(CURDIR)/debian/$(pkgapps)/usr/bin ] ; then \
		find $(CURDIR)/debian/$(pkgapps)/usr/bin -type l -xtype l -delete ; \
	fi
	$(CURDIR)/debian/generate_manpages

execute_after_dh_link-arch:
	# Some binaries (eg. splazer) are not built in 32-bit architectures so
	# remove their (broken) symlinks.
	if [ -d $(CURDIR)/debian/$(pkgapps)/usr/bin ] ; then \
	    find $(CURDIR)/debian/$(pkgapps)/usr/bin -type l -xtype l -delete ; \
	fi

execute_after_dh_fixperms-arch:
	for bin in `ls $(CURDIR)/debian/$(pkgapps)/usr/lib/seqan/bin/*.sh` ; do \
	    chmod +x $(CURDIR)/debian/$(pkgapps)/usr/lib/seqan/bin/`basename $${bin}` ; \
	done

=== debian/watch ===
Version: 5

Template: Github
Owner: seqan
Project: seqan
